<?php

namespace AppBundle\Repository;

use AppBundle\Entity\User;

/**
 * TradeRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TradeRepository extends \Doctrine\ORM\EntityRepository
{
    public function getLastTradeList(int $tradeCount, string $state, User $user): ?array
    {
        $query = $this->createQueryBuilder('trade')
            ->leftJoin('trade.account', 'account')
            ->andWhere('trade.state = :state')
            ->andWhere('account.user = :user')
            ->setParameter('user', $user)
            ->setParameter('state', $state)
            ->orderBy('trade.id', 'DESC')
            ->setMaxResults($tradeCount)
            ->getQuery();

        $trades = $query->getResult();

        return $trades;
    }

    public function sumTradeList(string $state, User $user): float
    {
        $query = $this->createQueryBuilder('trade')
            ->leftJoin('trade.account', 'account')
            ->andWhere('trade.state = :state')
            ->andWhere('account.user = :user')
            ->setParameter('user', $user)
            ->setParameter('state', $state)
            ->select('SUM(trade.realizedPl) as sumTradeList')
            ->getQuery();

        $trades = $query->getSingleScalarResult();

        return floatval($trades);
    }
}
